﻿package {
	import flash.display.Stage;
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.geom.Rectangle;
	
	public class SimpleScrollBar extends MovieClip {
		private var scroll_rect:Rectangle;
		private var upper_limit:Number;
		private var range:Number;
		
		public function SimpleScrollBar() {
			drag_mc.buttonMode = true;
			drag_mc.mouseChildren = false
			drag_mc.addEventListener( MouseEvent.MOUSE_DOWN, press_drag );
			
			track_mc.buttonMode = true;
			track_mc.mouseChildren = false
			track_mc.addEventListener( MouseEvent.CLICK, click_track );
			
			set_limits();
			
		}
		
		private function press_drag( event:MouseEvent ):void {
			/***************************************************/
			drag_mc.stage.addEventListener( MouseEvent.MOUSE_UP, release_drag, false, 0, true );
			/***************************************************/ 
			drag_mc.startDrag( false, scroll_rect );
			drag_mc.addEventListener( Event.ENTER_FRAME, drag );
		}
		
		private function release_drag( event:MouseEvent ):void {
			drag_mc.removeEventListener( Event.ENTER_FRAME, drag );
			drag_mc.stage.removeEventListener( MouseEvent.MOUSE_UP, release_drag );
			drag_mc.stopDrag();
		}
		
		private function click_track( event:MouseEvent ):void {
			trace( "Click track" );
		}
		
		private function set_limits():void {
			scroll_rect = new Rectangle( track_mc.x, track_mc.y, 0, track_mc.height - drag_mc.height );
			upper_limit = track_mc.y;
			range = track_mc.height - drag_mc.height;
		}
		
		private function drag( event:Event ):void {
			var p = ( drag_mc.y - track_mc.y ) / range;
			dispatchEvent( new ScrollBarEvent( ScrollBarEvent.UPDATE, p ) );
		}
	}
}

